/* Generated by powerful Codeforces Tool
 * Author: xxxodarap
 * Time: 2023-09-08 01:16
**/

#include<bits/stdc++.h>
using namespace std;
namespace R = std::ranges;

#define F(i, a, e) for(ll i = (a); i < (e); i++)
#define R(i, e) F(i, 0, e)

typedef long long ll;
typedef double lf;
typedef complex<lf> cp;
typedef pair<int, int> pii;


template<class T> bool ckmin(T& a, const T& b) { return b < a ? a = b, 1 : 0; }
template<class T> bool ckmax(T& a, const T& b) { return a < b ? a = b, 1 : 0; }


const lf PI = acos(-1), EPSI = 1e-9;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


// =============== Solution section ===============
const ll MAXN = 2e5 + 5;
const ll INF = 1LL << 60;

struct pt {
  lf x, y;
};
lf dist(pt p1, pt p2) {
  return sqrt((p1.x - p2.x) * (p1.x - p2.x) + (p1.y - p2.y) * (p1.y - p2.y));
}
bool compareX(const pt &a, const pt &b) { return a.x < b.x; }
bool compareY(const pt &a, const pt &b) { return a.y < b.y; }
lf bruteForce(pt P[], int n) {
  lf min = 1e100;
  for (int i = 0; i < n; ++i)
    for (int j = i + 1; j < n; ++j)
      if (dist(P[i], P[j]) < min)
        min = dist(P[i], P[j]);
  return min;
}
lf stripClosest(pt strip[], int size, lf d) {
  lf min = d;
  for (int i = 0; i < size; ++i)
    for (int j = i + 1; j < size && (strip[j].y - strip[i].y) < min; ++j)
      if (dist(strip[i], strip[j]) < min)
        min = dist(strip[i], strip[j]);
  return min;
}
lf closestUtil(pt Px[], pt Py[], int n) {
  if (n <= 3)
    return bruteForce(Px, n);
  int mid = n / 2;
  pt midpt = Px[mid];
  pt Pyl[mid + 1], Pyr[n - mid];
  int li = 0, ri = 0;
  for (int i = 0; i < n; i++)
    if (Py[i].x <= midpt.x)
      Pyl[li++] = Py[i];
    else
      Pyr[ri++] = Py[i];
  lf dl = closestUtil(Px, Pyl, mid);
  lf dr = closestUtil(Px + mid, Pyr, n - mid);
  lf d = min(dl, dr);
  pt strip[n];
  int j = 0;
  for (int i = 0; i < n; i++)
    if (abs(Py[i].x - midpt.x) < d)
      strip[j++] = Py[i];
  return min(d, stripClosest(strip, j, d));
}
lf closest(pt P[], int n) {
  pt Px[n], Py[n];
  for (int i = 0; i < n; i++)
    Px[i] = Py[i] = P[i];
  sort(Px, Px + n, compareX);
  sort(Py, Py + n, compareY);
  return closestUtil(Px, Py, n);
}


cp a, b;
/* // from reference */
/* bool cm(cp a, cp b){return imag(a)<imag(b);}; */
/* lf closest(vector<cp> P) { */
/*   R::sort(P, {}, [](cp a) {return real(a);}); */
/*   set<cp, decltype(&cm)> s(&cm); */
/*   lf mn = INFINITY; */
/*   auto pj_it = begin(P); */
/*   for (cp pi : P) { */
/*     while (real(pi) - real(*pj_it) >= mn) */
/*       s.erase(*pj_it++); */
/*     auto it1 = s.lower_bound(pi - mn * 1i); */
/*     auto it2 = s.upper_bound(pi + mn * 1i); */
/*     for (cp k : R::subrange(it1, it2)) */
/*       /1* mn = min(mn, abs(pi - k)); *1/ */
/*       if(abs(pi - k) < mn) */
/*         mn = abs(pi - k), a = pi, b = k; */
/*     s.insert(pi); */
/*   } */
/*   return mn; */
/* } */
//

ifstream fin("input.txt");
ofstream fout("output.txt");


ll N;

void solve(){
    // Code goes here ...
    fin >> N;
    vector<int> xs(N), ys(N);
    R(i, N) fin >> xs[i] >> ys[i];  
    
    vector<cp> points(N);
    vector<int> ks(N);
    R(i, N){
        points[i] = {abs(xs[i]), abs(ys[i])};
        ks[i] = 1 + (xs[i] < 0 ? 1 : 0) + (ys[i] < 0 ? 2 : 0);
    }

    lf x = closest(points);

    int ia = -1, ka, ib = -1, kb;
    R(i, N){
        if(a == points[i]) ia = i;
        if(b == points[i]) ib = i;
    }

    /* assert(ia != -1 and ib != -1); */
    if(ia == -1 or ib == -1){
        cout << "NOOO" << endl;
        return;
    }
    ka = ks[ia];
    kb = 5 - ks[ib];

    /* cerr << "Closest points are: " << points[ia] << " and " << points[ib] << endl; */
    /* cerr << " with conversion numbers " << ka << " and " << 5 - kb << endl; */

    fout << ia + 1 << " " << ka << " " << ib + 1 << " " << kb << endl;
    /* fout << format("%d %d %d %d\n", ia + 1, ka, ib + 1, kb); */
}


// =============== Main section ===============
int main(){
    ios_base::sync_with_stdio(0); fin.tie(0);
    cout << setprecision(12); // << fixed;

    /* int T = 1; */
    /* cin >> T; */
    /* while(T--) */
        solve();

    /* string rest; */
    /* while(cin.peek() != char_traits<char>::eof()){ */
    /*     solve(); */
    /*     getline(cin, rest); */
    /* } */

    return 0;
}
        
